`timescale 1ns/1ns
//clk parameter
`define halfperiod 10
`define reset_time 100
`define encoder_pluse_peiod_2 500000   //1ms
`define encoder_pluse_peiod_4 250000   //1ms
`define turnright 50
`define turnleft 80

module test_bech(clk,rst,chipselect,address,write,read,writedata,byteenable,pulse_in);
//write it for encode demo
output clk;
output rst;
//bus singal generation
output chipselect;
output [1:0] address;
output write;
output read;
output [31:0] writedata;  
output [3:0] byteenable;
// motor signal
output [1:0] pulse_in; 
reg [1:0] pulse_in;
//
reg clk;
reg rst;
//
reg chipselect;
reg [1:0] address;
reg write; reg read;
reg [31:0] writedata; 
reg [3:0] byteenable;

//
reg[32:0] i;
reg[32:0] k;

initial 
begin
     clk=0;rst=1;pulse_in[0]=0;pulse_in[1]=0;
	 chipselect=1;read=1;write=0;writedata=0;byteenable='hF;address=0;//output the count
     #20 rst=0;
     #(`reset_time) rst=1;
end
 
always
  #(`halfperiod) clk<=~clk;
//////////////////////////////////////////////////
//encoder wave generate//
/////////////////////////////////////////////////
initial 
   begin
		pulse_in[0]<=0;
		for(i=0;i<2*`turnright+2*`turnleft;i=i+1)
			begin		
				#(`encoder_pluse_peiod_2) pulse_in[0]<=~pulse_in[0];
			end
   end

initial 
   begin
		pulse_in[1]<=0;
		#(`encoder_pluse_peiod_4) pulse_in[1]<=1;
		for(k=0;k<2*`turnright;k=k+1)
			begin		
				#(`encoder_pluse_peiod_2) pulse_in[1]<=~pulse_in[1];
			end
		#(`encoder_pluse_peiod_2) pulse_in[1]<=pulse_in[1];
		for(k=0;k<2*`turnleft;k=k+1)
			begin		
				#(`encoder_pluse_peiod_2) pulse_in[1]<=~pulse_in[1];
			end
   end
endmodule



